#include "text.h"

/*
 *  Constructs a TextDlg as a child of 'parent', with the
 *  name 'name' and widget flags set to 'f'.
 *
 *  The dialog will by default be modeless, unless you set 'modal' to
 *  TRUE to construct a modal dialog.
 */
TextDlg::TextDlg( QWidget* parent, const char* name, bool modal, WFlags fl )
    : QDialog( parent, name, modal, fl )

{
    if ( !name )
	setName( "TextDlg" );
    setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)0, (QSizePolicy::SizeType)0, 0, 0, sizePolicy().hasHeightForWidth() ) );
    setMinimumSize( QSize( 600, 570 ) );
    setMaximumSize( QSize( 600, 570 ) );

    groupBox1 = new QGroupBox( this, "groupBox1" );
    groupBox1->setGeometry( QRect( 20, 0, 561, 330 ) );
    groupBox1->setFrameShape( QGroupBox::GroupBoxPanel );
    groupBox1->setFrameShadow( QGroupBox::Sunken );

    Y = new QSpinBox( groupBox1, "Y" );
    Y->setGeometry( QRect( 440, 70, 70, 21 ) );
    Y->setMaxValue( 1200 );

    X = new QSpinBox( groupBox1, "X" );
    X->setGeometry( QRect( 440, 30, 70, 21 ) );
    X->setMaxValue( 2048 );

    W = new QSpinBox( groupBox1, "W" );
    W->setGeometry( QRect( 440, 110, 70, 21 ) );
    W->setMaxValue( 2048 );

    H = new QSpinBox( groupBox1, "H" );
    H->setGeometry( QRect( 440, 150, 70, 21 ) );
    H->setMaxValue( 1200 );

    textLabel1 = new QLabel( groupBox1, "textLabel1" );
    textLabel1->setGeometry( QRect( 400, 30, 40, 21 ) );
    textLabel1->setAlignment( int( QLabel::AlignVCenter | QLabel::AlignRight ) );

    textLabel2 = new QLabel( groupBox1, "textLabel2" );
    textLabel2->setGeometry( QRect( 400, 70, 40, 21 ) );
    textLabel2->setAlignment( int( QLabel::AlignVCenter | QLabel::AlignRight ) );

    WidthLabel = new QLabel( groupBox1, "WidthLabel" );
    WidthLabel->setGeometry( QRect( 380, 110, 60, 21 ) );
    WidthLabel->setAlignment( int( QLabel::AlignVCenter | QLabel::AlignRight ) );

    HeightLabel = new QLabel( groupBox1, "HeightLabel" );
    HeightLabel->setGeometry( QRect( 380, 150, 60, 21 ) );
    HeightLabel->setAlignment( int( QLabel::AlignVCenter | QLabel::AlignRight ) );

    ValueLabel = new QLabel( groupBox1, "ValueLabel" );
    ValueLabel->setGeometry( QRect( 20, 20, 221, 16 ) );

    AlignLabel = new QLabel( groupBox1, "AlignLabel" );
    AlignLabel->setGeometry( QRect( 10, 180, 50, 21 ) );
    AlignLabel->setAlignment( int( QLabel::AlignVCenter | QLabel::AlignRight ) );

    FontLabel = new QLabel( groupBox1, "FontLabel" );
    FontLabel->setGeometry( QRect( 10, 210, 50, 21 ) );
    FontLabel->setAlignment( int( QLabel::AlignVCenter | QLabel::AlignRight ) );

    comboBox2 = new QComboBox( FALSE, groupBox1, "comboBox2" );
    comboBox2->setGeometry( QRect( 70, 180, 111, 21 ) );

    FontCombo = new KFontCombo( groupBox1, "FontCombo" );
    FontCombo->setGeometry( QRect( 70, 210, 151, 21 ) );

    spinBox5 = new QSpinBox( groupBox1, "spinBox5" );
    spinBox5->setGeometry( QRect( 340, 210, 55, 21 ) );
    spinBox5->setValue(10);

    ShadowLabel = new QLabel( groupBox1, "ShadowLabel" );
    ShadowLabel->setGeometry( QRect( 240, 250, 91, 21 ) );
    ShadowLabel->setAlignment( int( QLabel::AlignVCenter | QLabel::AlignRight ) );

    spinBox6 = new QSpinBox( groupBox1, "spinBox6" );
    spinBox6->setGeometry( QRect( 340, 250, 55, 20 ) );
    spinBox6->setMinValue( -99 );

    pushButton3 = new QPushButton( groupBox1, "pushButton3" );
    pushButton3->setGeometry( QRect( 430, 210, 121, 21 ) );
    pushButton3->setPaletteBackgroundColor( QColor( 255, 255, 255 ) );

    pushButton4 = new QPushButton( groupBox1, "pushButton4" );
    pushButton4->setGeometry( QRect( 430, 240, 121, 21 ) );
    pushButton4->setPaletteForegroundColor( QColor( 255, 255, 255 ) );
    pushButton4->setPaletteBackgroundColor( QColor( 0, 0, 0 ) );

    checkBox2 = new QCheckBox( groupBox1, "checkBox2" );
    checkBox2->setGeometry( QRect( 30, 290, 85, 20 ) );

    ScrollLabel = new QLabel( groupBox1, "ScrollLabel" );
    ScrollLabel->setGeometry( QRect( 160, 290, 83, 20 ) );
    ScrollLabel->setAlignment( int( QLabel::AlignVCenter | QLabel::AlignRight ) );

    spinBox7 = new QSpinBox( groupBox1, "spinBox7" );
    spinBox7->setGeometry( QRect( 250, 290, 55, 20 ) );
    spinBox7->setMinValue( -99 );

    MscrollLabel = new QLabel( groupBox1, "MscrollLabel" );
    MscrollLabel->setGeometry( QRect( 340, 290, 143, 20 ) );
    MscrollLabel->setAlignment( int( QLabel::AlignVCenter | QLabel::AlignRight ) );

    spinBox8 = new QSpinBox( groupBox1, "spinBox8" );
    spinBox8->setGeometry( QRect( 490, 289, 55, 20 ) );
    spinBox8->setMaxValue( 2048 );

    Value = new QTextEdit( groupBox1, "Value" );
    Value->setGeometry( QRect( 20, 40, 340, 130 ) );

    FsizeLabel = new QLabel( groupBox1, "FsizeLabel" );
    FsizeLabel->setGeometry( QRect( 240, 210, 90, 21 ) );
    FsizeLabel->setAlignment( int( QLabel::AlignVCenter | QLabel::AlignRight ) );

// Sensor Group
    SensorBox = new QGroupBox( this, "SensorBox" );
    SensorBox->setGeometry( QRect( 20, 340, 561, 160 ) );

    useSens = new QCheckBox( SensorBox, "useSens" );
    useSens->setGeometry( QRect( 20, 20, 160, 21 ) );

    SensorCombo = new QComboBox( FALSE, SensorBox, "SensorCombo" );
    SensorCombo->setEnabled( FALSE );
    SensorCombo->setGeometry( QRect( 290, 20, 171, 21 ) );

    Format = new QLineEdit( SensorBox, "Format" );
    Format->setEnabled( FALSE );
    Format->setGeometry( QRect( 110, 50, 160, 21 ) );

    Codec = new QLineEdit( SensorBox, "Codec" );
    Codec->setEnabled( FALSE );
    Codec->setGeometry( QRect( 110, 90, 160, 21 ) );

    Line = new QLineEdit( SensorBox, "Line" );
    Line->setEnabled( FALSE );
    Line->setGeometry( QRect( 390, 90, 160, 21 ) );

    Program = new QLineEdit( SensorBox, "Program" );
    Program->setEnabled( FALSE );
    Program->setGeometry( QRect( 390, 50, 160, 21 ) );
    Program->setReadOnly( FALSE );

    RDF = new QCheckBox( SensorBox, "RDF" );
    RDF->setGeometry( QRect( 20, 130, 160, 21 ) );
    RDF->setEnabled( FALSE );

    LineLabel = new QLabel( SensorBox, "LineLabel" );
    LineLabel->setEnabled( FALSE );
    LineLabel->setGeometry( QRect( 290, 90, 90, 21 ) );
    LineLabel->setAlignment( int( QLabel::AlignVCenter | QLabel::AlignRight ) );

    ProgramLabel = new QLabel( SensorBox, "ProgramLabel" );
    ProgramLabel->setEnabled( FALSE );
    ProgramLabel->setGeometry( QRect( 270, 50, 110, 21 ) );
    ProgramLabel->setAlignment( int( QLabel::AlignVCenter | QLabel::AlignRight ) );

    FormatLabel = new QLabel( SensorBox, "FormatLabel" );
    FormatLabel->setEnabled( FALSE );
    FormatLabel->setGeometry( QRect( 10, 50, 90, 21 ) );
    FormatLabel->setAlignment( int( QLabel::AlignVCenter | QLabel::AlignRight ) );

    CodecLabel = new QLabel( SensorBox, "CodecLabel" );
    CodecLabel->setEnabled( FALSE );
    CodecLabel->setGeometry( QRect( 10, 90, 90, 21 ) );
    CodecLabel->setAlignment( int( QLabel::AlignVCenter | QLabel::AlignRight ) );

    SensorLabel = new QLabel( SensorBox, "SensorLabel" );
    SensorLabel->setEnabled( FALSE );
    SensorLabel->setGeometry( QRect( 190, 20, 80, 21 ) );
    SensorLabel->setAlignment( int( QLabel::AlignVCenter | QLabel::AlignRight ) );

// Global
    insCur = new QCheckBox( this, "insCur" );
    insCur->setGeometry( QRect( 20, 500, 300, 20 ) );

    pushButton2 = new QPushButton( this, "pushButton2" );
    pushButton2->setGeometry( QRect( 340, 530, 81, 31 ) );
    pushButton2->setIconSet( SmallIconSet( "cancel" ));

    pushButton1 = new QPushButton( this, "pushButton1" );
    pushButton1->setGeometry( QRect( 190, 530, 81, 31 ) );
    pushButton1->setIconSet( SmallIconSet( "ok" ));
    pushButton1->setDefault( TRUE );

    languageChange();

    // signals and slots connections
    connect( pushButton1, SIGNAL( clicked() ), this, SLOT( accept() ) );
    connect( pushButton2, SIGNAL( clicked() ), this, SLOT( close() ) );
    connect( pushButton3, SIGNAL( clicked() ), this, SLOT( selColor() ) );
    connect( pushButton4, SIGNAL( clicked() ), this, SLOT( selShadow() ) );
    connect( SensorCombo, SIGNAL( activated(const QString&) ), this, SLOT( ChooseProgram() ) );
    connect( useSens, SIGNAL( toggled(bool) ), this, SLOT( UseSensor(bool) ) );
}

/*
 *  Destroys the object and frees any allocated resources
 */
TextDlg::~TextDlg()
{
    // no need to delete child widgets, Qt does it all for us
}

/*
 *  Sets the strings of the subwidgets using the current
 *  language.
 */
void TextDlg::languageChange()
{
    setCaption( tr2i18n( "Add Text Meter" ) );
    groupBox1->setTitle( tr2i18n( "Text Parameters" ) );
    Y->setPrefix( QString::null );
    Y->setSuffix( tr2i18n( "px" ) );
    X->setPrefix( QString::null );
    X->setSuffix( tr2i18n( "px" ) );
    W->setPrefix( QString::null );
    W->setSuffix( tr2i18n( "px" ) );
    H->setPrefix( QString::null );
    H->setSuffix( tr2i18n( "px" ) );
    spinBox6->setSuffix( tr2i18n( "px" ) );
    spinBox7->setSuffix( tr2i18n( "px" ) );
    spinBox8->setSuffix( tr2i18n( "px" ) );
    textLabel1->setText( tr2i18n( "X axis:" ) );
    textLabel2->setText( tr2i18n( "Y axis:" ) );
    WidthLabel->setText( tr2i18n( "Width:" ) );
    HeightLabel->setText( tr2i18n( "Height:" ) );
    ValueLabel->setText( tr2i18n( "Value:" ) );
    AlignLabel->setText( tr2i18n( "Align:" ) );
    FontLabel->setText( tr2i18n( "Font:" ) );
    comboBox2->clear();
    comboBox2->insertItem( tr2i18n( "Left" ) );
    comboBox2->insertItem( tr2i18n( "Center" ) );
    comboBox2->insertItem( tr2i18n( "Right" ) );
    ShadowLabel->setText( tr2i18n( "Shadow" ) );
    pushButton3->setText( tr2i18n( "Font Color" ) );
    pushButton4->setText( tr2i18n( "Shadow Color" ) );
    checkBox2->setText( tr2i18n( "Fixedpitch" ) );
    ScrollLabel->setText( tr2i18n( "Scrolling:" ) );
    MscrollLabel->setText( tr2i18n( "Max scroll:" ) );
    FsizeLabel->setText( tr2i18n( "Font Size:" ) );
    pushButton2->setText( tr2i18n( "Cancel" ) );
    pushButton1->setText( tr2i18n( "Ok" ) );
    SensorBox->setTitle( tr2i18n( "Sensor" ) );
    SensorCombo->clear();
    SensorCombo->insertItem( tr2i18n( "CPU" ) );
    SensorCombo->insertItem( tr2i18n( "Memory" ) );
    SensorCombo->insertItem( tr2i18n( "Disk" ) );
    SensorCombo->insertItem( tr2i18n( "Network" ) );
    SensorCombo->insertItem( tr2i18n( "Time" ) );
    SensorCombo->insertItem( tr2i18n( "Uptime" ) );
    SensorCombo->insertItem( tr2i18n( "Sensor" ) );
    SensorCombo->insertItem( tr2i18n( "Textfile" ) );
    SensorCombo->insertItem( tr2i18n( "Noatun" ) );
    SensorCombo->insertItem( tr2i18n( "XMMS" ) );
    SensorCombo->insertItem( tr2i18n( "Program" ) );
    Format->setText( tr2i18n( "%v" ) );
    ProgramLabel->setText( tr2i18n( "Program:" ) );
    LineLabel->setText( tr2i18n( "Line:" ) );
    FormatLabel->setText( tr2i18n( "Format:" ) );
    SensorLabel->setText( tr2i18n( "Sensor:" ) );
    CodecLabel->setText( tr2i18n( "Encoding:" ) );
    RDF->setText( tr2i18n( "RDF file" ) );
    useSens->setText( tr2i18n( "Use sensor" ) );
    insCur->setText( tr2i18n( "Insert at cursor position" ) );
}

void TextDlg::UseSensor( bool v ){
  SensorLabel->setEnabled(v);
  SensorCombo->setEnabled(v);
  Format->setEnabled(v);
  FormatLabel->setEnabled(v);
  LineLabel->setEnabled(v);
  Line->setEnabled(v);
  ProgramLabel->setEnabled(v);
  Program->setEnabled(v);
  CodecLabel->setEnabled(v);
  Codec->setEnabled(v);
  RDF->setEnabled(v);
  Value->setEnabled(!v);
  ValueLabel->setEnabled(!v);
  if(v){
    ChooseProgram();
  }
}

void TextDlg::ChooseProgram(){
  if(SensorCombo->currentItem() == 0){
    ProgramLabel->setEnabled(false);
    Program->setEnabled(false);
    CodecLabel->setEnabled(false);
    Codec->setEnabled(false);
    FormatLabel->setEnabled(true);
    Format->setEnabled(true);
    Format->setText("%load");
    QToolTip::add( Format, tr2i18n( "%user<br>%system<br>%nice<br>%idle<br>%load (=%v)" ) );
    LineLabel->setEnabled(true);
    LineLabel->setText( tr2i18n( "CPU:" ) );
    Line->setEnabled(true);
    Line->setText("all");
    RDF->setEnabled(false);
  }
  else if(SensorCombo->currentItem() == 1){
    ProgramLabel->setEnabled(false);
    Program->setEnabled(false);
    CodecLabel->setEnabled(false);
    Codec->setEnabled(false);
    FormatLabel->setEnabled(true);
    Format->setEnabled(true);
    Format->setText("%fm");
    QToolTip::add( Format, tr2i18n( "%fm<br>%fmb<br>%um<br>%umb<br>%tm<br>%fs<br>%us<br>%ts" ) );
    LineLabel->setEnabled(false);
    Line->setEnabled(false);
    RDF->setEnabled(false);
  }
  else if(SensorCombo->currentItem() == 2){
    ProgramLabel->setEnabled(true);
    ProgramLabel->setText( tr2i18n( "MountPoint:" ) );
    Program->setEnabled(true);
    Program->setText("/");
    CodecLabel->setEnabled(false);
    Codec->setEnabled(false);
    FormatLabel->setEnabled(true);
    Format->setEnabled(true);
    Format->setText("%f");
    QToolTip::add( Format, tr2i18n( "%f<br>%fp<br>%u<br>%up<br>%t" ) );
    LineLabel->setEnabled(false);
    Line->setEnabled(false);
    RDF->setEnabled(false);
  }
  else if(SensorCombo->currentItem() == 3){
    ProgramLabel->setEnabled(true);
    ProgramLabel->setText( tr2i18n( "Device:" ) );
    Program->setEnabled(true);
    Program->setText("eth0");
    CodecLabel->setEnabled(false);
    Codec->setEnabled(false);
    FormatLabel->setEnabled(true);
    Format->setEnabled(true);
    Format->setText("%in");
    QToolTip::add( Format, tr2i18n( "%in<br>%out" ) );
    LineLabel->setEnabled(true);
    LineLabel->setText( tr2i18n( "Decimals:" ) );
    Line->setEnabled(true);
    Line->setText("0");
    RDF->setEnabled(false);
  }
  else if(SensorCombo->currentItem() == 4){
    ProgramLabel->setEnabled(false);
    Program->setEnabled(false);
    CodecLabel->setEnabled(false);
    Codec->setEnabled(false);
    FormatLabel->setEnabled(true);
    Format->setEnabled(true);
    Format->setText("dd.MM.yyyy");
    QToolTip::add( Format, tr2i18n( "d<br>dd<br>ddd<br>dddd<br>M<br>MM<br>MMM<br>MMMM<br>YY<br>YYYY<br>h<br>hh<br>m<br>mm<br>s<br>ss<br>z<br>zzz<br>AP<br>ap" ) );
    LineLabel->setEnabled(false);
    Line->setEnabled(false);
    RDF->setEnabled(false);
  }
  else if(SensorCombo->currentItem() == 5){
    ProgramLabel->setEnabled(false);
    Program->setEnabled(false);
    CodecLabel->setEnabled(false);
    Codec->setEnabled(false);
    FormatLabel->setEnabled(true);
    Format->setEnabled(true);
    Format->setText("%dd %h:%M");
    QToolTip::add( Format, tr2i18n( "%d<br>%h<br>%m<br>%s<br>%H<br>%M<br>%S" ) );
    LineLabel->setEnabled(false);
    Line->setEnabled(false);
    RDF->setEnabled(false);
  }
  else if(SensorCombo->currentItem() == 6){
    ProgramLabel->setEnabled(true);
    ProgramLabel->setText( tr2i18n( "Type:" ) );
    Program->setEnabled(true);
    Program->setText("temp2");
    CodecLabel->setEnabled(false);
    Codec->setEnabled(false);
    FormatLabel->setEnabled(true);
    Format->setEnabled(true);
    Format->setText("%v");
    QToolTip::add( Format, tr2i18n( "%v" ) );
    LineLabel->setEnabled(false);
    Line->setEnabled(false);
    RDF->setEnabled(false);
  }
  else if(SensorCombo->currentItem() == 7){
    ProgramLabel->setEnabled(true);
    ProgramLabel->setText( tr2i18n( "Path:" ) );
    Program->setEnabled(true);
    Program->setText("");
    CodecLabel->setEnabled(true);
    Codec->setEnabled(true);
    Codec->setText((QTextCodec::codecForLocale())->name());
    FormatLabel->setEnabled(true);
    Format->setEnabled(true);
    Format->setText("%v");
    QToolTip::add( Format, tr2i18n( "%v" ) );
    LineLabel->setEnabled(true);
    LineLabel->setText( tr2i18n( "Line:" ) );
    Line->setEnabled(true);
    Line->setText("");
    RDF->setEnabled(true);
  }
  else if(SensorCombo->currentItem() == 8){
    ProgramLabel->setEnabled(false);
    Program->setEnabled(false);
    CodecLabel->setEnabled(false);
    Codec->setEnabled(false);
    FormatLabel->setEnabled(true);
    Format->setEnabled(true);
    Format->setText("%id");
    QToolTip::add( Format, tr2i18n( "%id<br>%title<br>%time<br>%remain<br>%length<br>%full" ) );
    LineLabel->setEnabled(false);
    Line->setEnabled(false);
    RDF->setEnabled(false);
  }
  else if(SensorCombo->currentItem() == 9){
    ProgramLabel->setEnabled(false);
    Program->setEnabled(false);
    CodecLabel->setEnabled(true);
    Codec->setEnabled(true);
    Codec->setText((QTextCodec::codecForLocale())->name());
    FormatLabel->setEnabled(true);
    Format->setEnabled(true);
    Format->setText("%title");
    QToolTip::add( Format, tr2i18n( "%title<br>%time<br>%remain<br>%length<br>%full<br>%stitle<br>%artist<br>%album<br>%track<br>%cover<br>%rcover<br>%viewer<br>%rate<br>%freq<br>%channel<br>%monoster<br>%runquit<br>%vol<br>%volup<br>%voldown<br>%prev<br>%play<br>%pause<br>%stop<br>%next<br>%list<br>%ms" ) );
    LineLabel->setEnabled(false);
    Line->setEnabled(false);
    RDF->setEnabled(false);
  }
  else if(SensorCombo->currentItem() == 10){
    ProgramLabel->setEnabled(true);
    ProgramLabel->setText( tr2i18n( "Program:" ) );
    Program->setEnabled(true);
    CodecLabel->setEnabled(true);
    Codec->setEnabled(true);
    Codec->setText((QTextCodec::codecForLocale())->name());
    FormatLabel->setEnabled(true);
    Format->setEnabled(true);
    Format->setText("%v");
    QToolTip::add( Format, tr2i18n( "%v" ) );
    LineLabel->setEnabled(true);
    LineLabel->setText( tr2i18n( "Line:" ) );
    Line->setEnabled(true);
    Line->setText("");
    RDF->setEnabled(false);
  }
}

void TextDlg::selColor(){
  //QColor myColor;
  int result = KColorDialog::getColor( textColor );
   if ( result == KColorDialog::Accepted ){
      pushButton3->setPaletteBackgroundColor( textColor );
   }
}

void TextDlg::selShadow(){
  //QColor myColor;
  int result = KColorDialog::getColor( shadow );
   if ( result == KColorDialog::Accepted ){
      pushButton4->setPaletteBackgroundColor( shadow );
   }
}

#include "text.moc"
